com.sun.jdi.request

## Interface ClassPrepareRequest

- All Superinterfaces:
    EventRequest, Mirror

      @Exported
      public interface ClassPrepareRequest
      extends EventRequest

  Request for notification when a class is prepared in the target VM. When an enabled ClassPrepareRequest is satisfied, an `event set` containing a `ClassPrepareEvent` will be placed on the `EventQueue`. The collection of existing ClassPrepareRequests is managed by the `EventRequestManager`

  Class preparation is defined in the Java Virtual Machine Specification.

  Since:
    1.3
  See Also:
    `ClassPrepareEvent`, `EventQueue`, `EventRequestManager`

- - ### Field Summary

    - ### Fields inherited from interface com.sun.jdi.request.EventRequest

      `SUSPEND_ALL, SUSPEND_EVENT_THREAD, SUSPEND_NONE`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addClassExclusionFilter(String classPattern)` | Restricts the events generated by this request to the preparation of reference types whose name does not match this restricted regular expression.
    `void` | `addClassFilter(ReferenceType refType)` | Restricts the events generated by this request to be the preparation of the given reference type and any subtypes.
    `void` | `addClassFilter(String classPattern)` | Restricts the events generated by this request to the preparation of reference types whose name matches this restricted regular expression.
    `void` | `addSourceNameFilter(String sourceNamePattern)` | Restricts the events generated by this request to the preparation of reference types for which the restricted regular expression 'sourceNamePattern' matches one of the 'sourceNames' for the reference type being prepared.

    - ### Methods inherited from interface com.sun.jdi.request.EventRequest

      `addCountFilter, disable, enable, getProperty, isEnabled, putProperty, setEnabled, setSuspendPolicy, suspendPolicy`

    - ### Methods inherited from interface com.sun.jdi.Mirror

      `toString, virtualMachine`

- - ### Method Detail

    - #### addClassFilter

          void addClassFilter(ReferenceType refType)

      Restricts the events generated by this request to be the preparation of the given reference type and any subtypes. An event will be generated for any prepared reference type that can be safely cast to the given reference type.
      Parameters:
        `refType` - the reference type to filter on.
      Throws:
        `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

    - #### addClassFilter

          void addClassFilter(String classPattern)

      Restricts the events generated by this request to the preparation of reference types whose name matches this restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
      Parameters:
        `classPattern` - the pattern String to filter for.
      Throws:
        `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

    - #### addClassExclusionFilter

          void addClassExclusionFilter(String classPattern)

      Restricts the events generated by this request to the preparation of reference types whose name does not match this restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
      Parameters:
        `classPattern` - the pattern String to filter against.
      Throws:
        `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

    - #### addSourceNameFilter

          void addSourceNameFilter(String sourceNamePattern)

      Restricts the events generated by this request to the preparation of reference types for which the restricted regular expression 'sourceNamePattern' matches one of the 'sourceNames' for the reference type being prepared. That is, if refType is the ReferenceType being prepared, then there exists at least one stratum, call it 'someStratum' on the list returned by refType.availableStrata(); such that a name on the list returned by refType.sourceNames(someStratam) matches 'sourceNamePattern'. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".

      Not all targets support this operation. Use `VirtualMachine.canUseSourceNameFilters()` to determine if the operation is supported.

      Parameters:
        `sourceNamePattern` - the pattern string to filter for.
      Throws:
        `UnsupportedOperationException` - if the target virtual machine does not support this operation.
        `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.
      Since:
        1.6

Copyright © 1999, 2026, Oracle and/or its affiliates. All rights reserved.